# $Id: comlinklib.pl,v 1.5 1996/11/13 18:00:35 moritz Exp $
# Library fuer ComLink-relevante Perl-Routinen
#
# $Log: comlinklib.pl,v $
# Revision 1.5  1996/11/13 18:00:35  moritz
# avoid warnings with -w perl option
#
# Revision 1.4  1996/10/31 11:29:20  moritz
# comlinklib.pl verlegt von /usr/local/news nach /usr/local/lib,
# bevor es zu spaet ist
#

$ZCONNECT_ALIAS="/usr/local/lib/groupname-alias";


# Gibt fuer einen ZConnect-Brettnamen den RFC-Gruppennamen
# zurueck.
sub zc2rfcnews {
	local($name) = shift;
	local($m,$p);

	if (! $init_zconnect_alias_done) {
		&init_zconnect_alias;
	}
	$p="";
	if (defined $zconnect_alias{$name}) {
		return $zconnect_alias{$name};
	}

	foreach $m (keys %zconnect_map) {
		if (substr($name, $[, length($m)) eq $m) {
			# match
			$p=$zconnect_map{$m};
			$name=substr($name, $[ + length($m));
			last;
		}
	}

	$name =~ s|^/(.*)$|$1|;
	$name =~ tr|A-Z/\!|a-z._|;
	$p.$name;
}

sub init_zconnect_alias {
	open(ALIAS, "<$ZCONNECT_ALIAS") || die "Can't read zconnect alias file \"$ZCONNECT_ALIAS\": $!\n";
	while(<ALIAS>) {
		next if /^#/;
		($k, $zc, $rfc) = /(Alias|Map)\:\s*(\S+)\s+(\S+)$/;
		next if (! $k);
		if ($k =~ /Map/) {
			$zconnect_map{$zc}=$rfc;
		}
		elsif ($k =~ /Alias/) {
			$zconnect_alias{$zc}=$rfc;
		}
	}
	close ALIAS;
	$init_zconnect_alias_done=1;
}

# liest einen "Headerblock" aus user.dat oder netz.dat o.ae.
# $1 ist ein offener Filehandle
sub read_zerb_header_block {
        my($file) = shift;
        my(%data);
	my($i) = 0;

        while(1) {
                $_ = <$file> || last;
		chop;
                s/\r//; # CR
                last if /^$/;
                # Soak in header block
                ($name, $value) = /^([\w\-\_\d]+):\s*(.*)$/;
                $data{$name}=$value;
		$i++;
        }
        return ($i > 0) ? \%data : undef;
}


1;
